Gtk = imports.gi.Gtk;
GLib = imports.gi.GLib;
WebKit = imports.gi.WebKit;
Soup = imports.gi.Soup;

TabbedBrowser = imports.TabbedBrowser;
BrowserSettings = imports.BrowserSettings;
BrowserTab = imports.BrowserTab;

File = imports.File.File;

base64 = imports.base64.base64;

BrowserView = new GType({
    parent: WebKit.WebView.type,
    name: "BrowserView",
    init: function ()
    {
        // Private
        
 	var sess  = WebKit.get_default_session();
	sess.proxy_uri = new Soup.URI.c_new('http://localhost:3128');       
        var _t = this;
        
        var tab = BrowserTab;
        var browsePage = false;
        var maxQueue = 0;
        var injected = {};
        
        var current_url = '';
 
        var update_title = function (web_view, web_frame, title)
        {
            
            print("calling update title");
            if(title.length > 25)
                title = title.slice(0,25) + "...";

            tab.get_tab_label().label = title;
        };
        
        
        
           
        
        var traversedom = function(doc, fn, sub ) {
            print("TRAVERSE DOM?");
            sub = sub || 0;
            
            var ret = '<HTML>';
            
            var cb =  function(s) {
                //print("CB:" + s);
                ret+=s;
            };
            cb.fn = fn;
            cb.sub = sub +1;
            print(doc);
            print(doc.head);
            print (doc.body);
            
             //Roo.select('body > div',true).each(function(el) {
            traverseDOMTree(cb, doc.head, 1);
            traverseDOMTree(cb, doc.body, 1);
           //print(ret);   
            File.write(cb.fn.replace(/\.html$/, '')+ (sub ? ('.' + sub  ) : '') + '.html' , ret +'</HTML>');
        
        };
         
        
        
        var traverseDOMTree = function(cb, currentElement, depth) {
            if (currentElement) {
                
                //if (currentElement.class_name.match(/roo-dynamic/)) {
                //    return;
                //}
                //print(currentElement.node_name);
                var j;
                var nodeName = currentElement.node_name;
                var tagName = currentElement.tag_name;
                
                if  (nodeName == '#text') {
                    cb(currentElement.node_value);
                    return;
                
                }
                if(nodeName == 'BR'){
                    cb("<BR/>");
                    return;
                }
               
                if (nodeName == 'SCRIPT') {
                     
                    return;
                }
                //if (nodeName == 'STYLE') {  return; }
                var i = 0;
              // Prints the node tagName, such as <A>, <IMG>, etc
                var outNodeName = nodeName;
                if (nodeName == 'IFRAME') {
                    //outNodeName  = 'DIV';
                }
                if (tagName) {
                    
                    
                    
                    
                    var attr = [];
                    
                    for(i = 0; i < currentElement.attributes.length;i++) {
                        var aname = currentElement.attributes.item(i).name;
                        //if (aname =='class' || aname == 'style') {
                        //    continue;
                        //}
                        if (aname =='src' && tagName == 'IFRAME') {
                            continue;
                        }
                        
                        attr.push(aname + '="' + currentElement.attributes.item(i).value + '"' );
                    }
                    if (tagName == 'IFRAME') {
                        attr.push('src="' + File.basename(cb.fn).replace(/\.html$/, '')+ '.' + cb.sub + '.html"' );
                    }
                    
                    //if (nodeName == 'IFRAME') {
                    //    attr.push('src="' + currentElement.attributes.item(i).value + embeded_file '"' );
                    //}
                    
                    //var style = elClassToStyle(currentElement);
                    //if (style.length) {
                    //    attr.push('style="' + style + '"' );
                    //}
                    
                    
                    //if (depth > 1000 && (tagName == 'BODY' || tagName == 'HEAD' )) {
                     //   cb("<DIV"+ ( attr.length ? (' ' + attr.join(' ') ) : '') + ">");
                    //} else {
                        cb("<"+outNodeName + ( attr.length ? (' ' + attr.join(' ') ) : '') + ">");
                        
                    //}
                } 
                else {
                  cb("[unknown tag]");
                }
                
                 if (nodeName == 'IFRAME') {
                    
                   
                    traversedom(currentElement.content_document,  cb.fn,  cb.sub )
                    cb.sub++;
                    cb("</IFRAME>");
                    return;
                }
                
                
                // Traverse the tree
                i = 0;
                var currentElementChild = currentElement.child_nodes.item(i);
                var allText = true;
                while (currentElementChild) {
                    // Formatting code (indent the tree so it looks nice on the screen)
                    
                    if  (currentElementChild.node_name == '#text') {
                       // if (currentElementChild.node_value.length) {
                            cb(currentElementChild.node_value);
                       // }
                        
                        i++;
                        currentElementChild=currentElement.child_nodes.item(i);
                        continue;
                    }   
                    allText = false;
                    //cb("\n");
                    //for (j = 0; j < depth; j++) {
                      // &#166 is just a vertical line
                    //  cb("  ");
                    //}//               
                    
                        
                    // Recursively traverse the tree structure of the child node
                    traverseDOMTree(cb, currentElementChild, depth+1);
                    i++;
                    currentElementChild=currentElement.child_nodes.item(i);
                }
                if (!allText) {
                    // The remaining code is mostly for formatting the tree
                    //cb("\n");
                    //for (j = 0; j < depth - 1; j++) {
                      //cb("  ");
                    //}     
                }
                if (tagName) {
                   // if (depth > 1000 && (tagName == 'BODY' || tagName == 'HEAD' )) {
                   //     cb("</DIV>");
                   // } else {
                        cb("</"+outNodeName+">");
                   // }
                    
                }
            }
        };
        

        var update_url = function (web_view, web_frame)
        {
            var toolbar = tab.get_toolbar();

            toolbar.set_url(web_frame.get_uri());
            toolbar.set_can_go_back(web_view.can_go_back());
            toolbar.set_can_go_forward(web_view.can_go_forward());
            
            
            
            
        };

    
      

        var create_new_tab = function (web_view, web_frame, new_web_view)
        {
            new_web_view = new BrowserView();
            new_web_view.signal.web_view_ready.connect(show_new_tab);
            return new_web_view;
        };

        var show_new_tab = function (new_web_view)
        {
            TabbedBrowser.browser.new_tab("", new_web_view);

            return false;
        };

        var hover_link = function (web_view, link, url)
        {
            tab.get_statusbar().set_status(url);
        };
         
        /*
        
        this.add_inject = function(force)
        {
            
            if (force || (typeof(injected[this.uri]) == 'undefined' )) {
                injected[this.uri] = 0;
            }
            if (injected[this.uri] > 2) {
                return;
            }
            injected[this.uri]++;
            var fn = __script_path__ + "/inject.js";
            if (File.exists(fn)) {
//                print("Adding inject");
                var newjs = File.read(__script_path__ + "/inject.js");
                TabbedBrowser.browser.current_tab().get_web_view().execute_script(
                    newjs
                    
                );
            }
            
        }
        */
        var after_login = false;
        
        
        var load_finished_called = false;
        
        var done_print = false;
        var queue_print = -1;
        
        
        var load_started = function(fr)
        {
            print("load started");
            queue_print++;
        }
        
        
        var do_print = function(web_frame) {
            
        
            var realprint = function() {
                print("realprint called - queue is " + queue_print);
                if (queue_print > 0) {
                    print("ignore print - queue is " + queue_print);
                    queue_print--;
                    return;
                }
                
                try {
                    
                    if (current_url.match(/theindependent\.sg\//) ) {
                        TabbedBrowser.browser.current_tab().get_web_view().execute_script(
                            File.read( __script_path__ + "/domains/theindependent.sg.js")
                        );
                                      
                    }
                    print("FETCHING");
                    //print(web_frame);
                    if (web_frame &&  BrowserSettings.export_filename_html  ) {
                        var html = traversedom(web_frame.get_dom_document(), BrowserSettings.export_filename_html);
                        //File.write(BrowserSettings.export_filename_html, html);
                        
                    } 
                     
                    if (!BrowserSettings.export_filename) {
                        if (!BrowserSettings.export_filename_html) {
                             print("no export filename / and html filename");
                            return;
                        }
                        
                        Seed.quit();
                    }
                    var mf = _t.get_main_frame();
                     
                    print("Creating paper");
                    var ar = Gtk.PaperSize.get_paper_sizes();
                    var psetup = new Gtk.PageSetup();
                    for(var i = 0; i < ar.length; i++) {
                        if (ar[i].get_name() =='iso_a2') {
                            psetup.set_paper_size(ar[i]);
                        }
                    }
                    print("doing print operation");
                    var p = new Gtk.PrintOperation({ export_filename : BrowserSettings.export_filename });
                    print("doing print operation - set page"); 

                    p.set_default_page_setup(psetup);
                    
                    print("doing print operation - print_full"); 
                    mf.print_full(p, Gtk.PrintOperationAction.EXPORT);
                    print("made image - exiting");
                    
                    Seed.quit();
                    return true;
                } catch(e) {
                    print("error occured");
                    print(JSON.stringify(e));
                }
            };
         
            
            
            if (done_print) {
               
                print("do_print called -- while already doing this... - restarting queue...");
                GLib.timeout_add(GLib.PRIORITY_DEFAULT, BrowserSettings.delay *1, realprint);
                
                return;
            }
            done_print = true;
            print("do_print called");
            
        
            TabbedBrowser.browser.current_tab().get_web_view().execute_script(
                    File.read( __script_path__ + "/domains/remove_print_css.js")
            );
            
            var url_p = current_url.split('/');
            var dom = url_p[2];
            var dom_p = url_p[2].split('.');
            var chk = dom_p.pop();
            chk = dom_p.pop() + '.' + chk;
            
            
            
            print("CHECK: " + chk +"\n");
            if (File.exists( __script_path__ + "/domains/" + chk + '.js')) {
                print("INCLUDING: " + __script_path__ + "/domains/"+ chk + ".js\n");
                TabbedBrowser.browser.current_tab().get_web_view().execute_script(
                    File.read( __script_path__ + "/domains/"+ chk + ".js")
                );
            }
             
            
            // motorme - requires a scroll to make content appear..
            if (current_url.match(/\.motorme\.my\//) ) {
                TabbedBrowser.browser.current_tab().get_web_view().execute_script("window.scrollTo(0,500);"); 
                              
            }
            
           
            print("Delay:" + BrowserSettings.delay);
         
         
         
            GLib.timeout_add(GLib.PRIORITY_DEFAULT, BrowserSettings.delay *1, realprint);
        }
        
        
        var weibo_added = false;
        
        var is_weibo = false;
        
        
        var load_finished = function (webkit, web_frame, wb)
        {
            
           
            
            if (!is_weibo) {
                do_print(web_frame);
                return;
            }
             
             
             print("load finished");
             if (weibo_added) {
                 
                 if (after_login === true) {
                     print("do print");
                     do_print();
                     return;
                     
                 }
                 if (after_login === false) {
                     return; // not here?
                 }
                 print("adding timeout?");
                 //return;
                GLib.timeout_add(GLib.PRIORITY_LOW, 2000, function() {
                    print("Redirecting after login?" + after_login);
                    
                    _t.browse(after_login);
                    after_login  = true;
                });
                return;
             }
            
            weibo_added = true;
            TabbedBrowser.browser.current_tab().get_web_view().execute_script(
                File.read( __script_path__ + "/weibo.js") 
            );
            print("run_weibo(" + JSON.stringify( BrowserSettings.username ) + ", " + JSON.stringify(BrowserSettings.passwd) + ");");
    
            TabbedBrowser.browser.current_tab().get_web_view().execute_script(
                    "run_weibo(" + JSON.stringify( BrowserSettings.username ) + ", " + JSON.stringify(BrowserSettings.passwd) + ");"
            );
            return;
    
            //    return;
            print(after_login);
            if (after_login !== false) {
                
//                return;
                // wait a bit then load the real page..
                GLib.timeout_add(GLib.PRIORITY_LOW, 500, function() {
                    print("Redirecting after login?");
                    _t.browse(after_login);
                });
                
                return;
            }
         
            if (load_finished_called) {
                return ;
            
            }
            load_finished_called = true;
            
          
               
        };
 
 
 
         

        var clicked_link = function (web_view, web_frame, request,
                                     action, decision, window)
        {
            if(action.get_reason() == WebKit.WebNavigationReason.LINK_CLICKED &&
               action.get_button() == 2)
            {
                browser.new_tab(request.get_uri(), null);
                return true;
            }

            return false;
        };

        // Public
        
        
        this.browse = function (url)
        {
            if(url.search("://") < 0)
                url = "http://" + url;
            
            current_url = url;
            
            print("BROWSE: " + url);
            if (url.match(/\/weibo\.com\//) && after_login === false) {
                is_weibo = true;
                after_login = url;
                url = "http://weibo.com/login.php";
            }
            else  if (url.match(/\/weibo\.com\//) && after_login !== false) {
                after_login = false;
            }
            print("BROWSE -really: " + url);
            this.open(url);
        };

        this.set_tab = function (new_tab)
        {
            tab = new_tab;
        };

        this.get_tab = function ()
        {
            return tab;
        };

    
        // Implementation
        //this.set_scroll_adjustments(null, null);
        
        //this.signal.title_changed.connect(update_title);
        //this.signal.load_committed.connect(load_committed);
        this.signal.load_finished.connect(load_finished);
        this.signal.load_started.connect(load_started);
       
	
        // For some reason, this segfaults seed in the instance init closure handler
        // Once that's fixed, uncommenting the next line will give middle-click-open-in-new tab
        //this.signal.navigation_policy_decision_requested.connect(clicked_link);

        //this.signal.hovering_over_link.connect(hover_link);

        this.signal.create_web_view.connect(create_new_tab);
        
        
         
//        print("ADDing console message sig handler");
        
        
         
        
        this.toFilename = function(url)
        {
            url = url.replace(/^http[s]*:\/\//, '');
            var p = url.split('/');
            p.unshift(storedir+'/output');
            for (var i =1 ;i < p.length; i++) {
                p[i] = encodeURIComponent(p[i]);
            
            }
            p[p.length-1] = decodeURIComponent(p[p.length-1]);
            ret = p.join('/');
            var dir = File.dirname(ret);
            File.mkdirall(dir);
            return ret;
            
        }
        this.checkdomain = function(comp)
        {
            var b = parseUri(this.uri);
            var d = parseUri(comp);
            return (d.host == b.host && d.protocol == b.protocol);
            
            
        }
        
        this.dupeCheck = function(url)
        {
            
           // order - return highest up the queue first..
            if (File.exists(downloaddir +'/' + encodeURIComponent(url))) {
                return downloaddir +'/' + encodeURIComponent(url);
            }
             if (File.exists(parsedir +'/' + encodeURIComponent(url))) {
                return parsedir +'/' + encodeURIComponent(url);
            }
            if (File.exists(donedir +'/' + encodeURIComponent(url))) {
                return donedir +'/' + encodeURIComponent(url);
            }
            return  false;
            
            
        }
        this.moveToParse = function(url)
        {
            var old = this.dupeCheck(url);
            var target =parsedir +'/' + encodeURIComponent(url);
            if (old == target) {
                return;
            }
            File.write(target, old ? File.read(old) : '');
            if (old) {
                File.remove(old);
            }
            
        }
        
        this.moveToDownload= function(url)
        {
            var old = this.dupeCheck(url);
            var target =downloaddir +'/' + encodeURIComponent(url);
            if (old == target) {
                return;
            }
            File.write(target, old ? File.read(old) : '');
            if (old) {
                File.remove(old);
            }
            
        }
        this.moveToDone= function(url)
        {
            var old = this.dupeCheck(url);
            var target = donedir +'/' + encodeURIComponent(url);
            if (old == target) {
                return;
            }
            File.write(target, old ? File.read(old) : '');
            if (old) {
                File.remove(old);
            }
            
        }
        
    }
});

function parseUri (str) {
	var	o   = parseUri.options,
		m   = o.parser[o.strictMode ? "strict" : "loose"].exec(str),
		uri = {},
		i   = 14;

	while (i--) uri[o.key[i]] = m[i] || "";

	uri[o.q.name] = {};
	uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
		if ($1) uri[o.q.name][$1] = $2;
	});

	return uri;
};

parseUri.options = {
	strictMode: false,
	key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],
	q:   {
		name:   "queryKey",
		parser: /(?:^|&)([^&=]*)=?([^&]*)/g
	},
	parser: {
		strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
		loose:  /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
	}
};
